/*
    Animation Class

    An OpenSceneGraph viewer for pyVolution .sww files.
    copyright (C) 2004-2005 Geoscience Australia
*/


#ifndef ANIMATION_H
#define ANIMATION_H


#include <osg/Image>
#include <customviewer.h>
#include <string>


class Animation
{

public:

   Animation();
   void setDirectory( std::string dirname );
   void setViewer( CustomViewer viewer );
   bool saveImage( unsigned int index );


protected:

   std::string _dirname;
   int _x, _y;
   unsigned int _width, _height;
   osg::ref_ptr<osg::Image> _image;
   bool _valid;
};


#endif  // ANIMATION_H
