
/*
    Head's up viewer class

    An OpenSceneGraph viewer for pyVolution SWW files.
    copyright (C) 2004 Geoscience Australia
*/


#ifndef HUD_H
#define HUD_H

#include <project.h>
#include <osg/Projection>
#include <osgText/Font>
#include <osgText/Text>


class HeadsUpDisplay
{

public:

    HeadsUpDisplay();
    virtual void setTime(float t);
    virtual void setTitle(char* s);
    virtual void setMode(char* s);
    virtual void update();
    virtual osg::Projection* get(){ return _projection; }

protected:

    osg::Projection* _projection;
    osgText::Text* _titletext;
    osgText::Text* _timetext;
    osgText::Text* _modetext;
    float _timevalue;
    std::string _modestring;
    std::string _titlestring;
    bool _dirtytime, _dirtymode, _dirtytitle;
    virtual ~HeadsUpDisplay();

};

#endif  // HUD_H
