
/*
    WaterSurface class

    An OpenSceneGraph viewer for pyVolution .sww files.
    copyright (C) 2004 Geoscience Australia
*/


#ifndef WATERSURFACE_H
#define WATERSURFACE_H


#include <project.h>
#include <SWWReader.h>
#include <osg/Geode>
#include <osg/StateAttribute>


class WaterSurface
{

public:

    WaterSurface(SWWReader *sww);
    virtual osg::Geode* get(){ return _node; }
    virtual void setTimeStep( unsigned int ts );

    virtual void setWireframe(bool value);
    virtual bool getWireframe(){ return _wireframe; };
    virtual void toggleWireframe(){ setWireframe( _wireframe ? false : true ); };

    virtual void setCulling(bool value);
    virtual bool getCulling(){ return _culling; };
    virtual void toggleCulling(){ setCulling( _culling ? false : true ); };

    virtual void update();

protected:

    SWWReader* _sww;
    osg::Geode* _node;
    osg::Geometry* _geom;
    osg::StateSet* _stateset;
    unsigned int _timestep;
    virtual ~WaterSurface();
    bool _wireframe, _dirtywireframe;
    bool _culling, _dirtyculling;
    bool _dirtydata;
};


#endif  // WATERSURFACE_H
